# Rhye's and Fall of Civilization - Constants


# globals

l0Array =       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
lm1Array =      [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1]

# initialise player variables to player IDs from WBS
iEgypt = 0
iIndia = 1
iChina = 2
iGreece = 3
iPersia = 4
iRome = 5
iJapan = 6
iArabia = 7
iSpain = 8
iFrance = 9
iEngland = 10
iGermany = 11
iRussia = 12
iMali = 13
iInca = 14
iMongolia = 15
iAztecs = 16
iAmerica = 17
iNumPlayers = 18
iNumMajorPlayers = 18
iNumActivePlayers = 18
iNumTotalPlayers = 18
iBarbarian = 18
iNumTotalPlayersB = 19


#for Congresses and Victory
lCivGroups = [[3, 5, 8, 9, 10, 11, 12], #Euros
                [1, 2, 4, 6, 12, 15], #Asian
                [0, 4, 7], #MiddleEastern
                [0, 3, 5], #Mediterranean
                [0, 13], #African
                [14, 16, 17]] #American

lCivStabilityGroups = [[iSpain, iFrance, iEngland, iGermany, iRussia],  #Euros
                [iIndia, iChina, iJapan, iMongolia], #Asian
                [iPersia, iArabia], #MiddleEastern
                [iEgypt, iGreece, iRome, iMali], #Mediterranean
                [iInca, iAztecs, iAmerica]] #American


lCivBioOldWorld = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 15, 17]
lCivBioNewWorld = [14, 16]


#for Victory and the handler
tAmericasTL = (3, 0)
tAmericasBR = (43, 63)


#for messages
iDuration = 14
iWhite = 0
iRed = 7
iGreen = 8
iBlue = 9
iLightBlue = 10
iYellow = 11
iDarkPink = 12
iLightRed = 20
iPurple = 25
iCyan = 44
iBrown = 55
iOrange = 88
iTan = 90
iLime = 100

#neighbours
lNeighbours = [
[3, 4, 5, 7], #Egypt
[2, 4, 15], #India
[1, 6, 15], #China
[4, 5, 11, 12], #Greece
[1, 3, 15], #Persia
[0, 3, 8, 9, 11], #Rome
[2, 15], #Japan
[0, 4], #Arabia
[5, 9, 10], #Spain
[5, 8, 10, 11], #France
[5, 8, 9, 11], #England
[5, 9, 10, 12], #Germany
[4, 11, 15], #Russia
[0], #Mali
[8, 16, 17], #Inca
[1, 2, 4, 6, 12], #Mongolia
[8, 14, 17], #Aztec
[6, 8, 9, 10, 12, 14, 16]] #America

#for stability hit on spawn
lOlderNeighbours = [
[], #Egypt
[], #India
[], #China
[iEgypt], #Greece
[iEgypt, iGreece], #Persia
[iEgypt, iGreece], #Rome
[], #Japan
[iEgypt, iPersia], #Arabia
[iRome], #Spain
[iRome], #France
[], #England
[iGreece, iRome], #Germany
[iPersia, iGreece], #Russia
[], #Mali
[], #Inca
[iChina, iJapan, iRussia], #Mongolia
[], #Aztec
[iSpain, iFrance, iEngland, iAztecs] #America
]


# civ birth dates

tBirth = (
0, #3000BC
0, #3000BC
0, #3000BC
50, #1600BC
84, #844BC
90, #753BC
97, #660BC
183, #622AD
193, #718AD
196, #751AD
203, #829AD
205, #843AD
207, #860AD
220, #989AD
236, #1150AD
240, #1190AD
241, #1195AD
346, #1775AD #332 for 1733AD
0)


tYear = (
("3000 ", "TXT_KEY_BC"),
("3000 ", "TXT_KEY_BC"),
("3000 ", "TXT_KEY_BC"),
("1600 ", "TXT_KEY_BC"),
("850 ", "TXT_KEY_BC"),
("760 ", "TXT_KEY_BC"),
("655 ", "TXT_KEY_BC"),
("620 ", "TXT_KEY_AD"),
("720 ", "TXT_KEY_AD"),
("750 ", "TXT_KEY_AD"),
("820 ", "TXT_KEY_AD"),
("840 ", "TXT_KEY_AD"),
("860 ", "TXT_KEY_AD"),
("980 ", "TXT_KEY_AD"),
("1150 ", "TXT_KEY_AD"),
("1190 ", "TXT_KEY_AD"),
("1200 ", "TXT_KEY_AD"),
("1775 ", "TXT_KEY_AD"))

tGoals = (
("TXT_KEY_UHV_EGY1", "TXT_KEY_UHV_EGY2", "TXT_KEY_UHV_EGY3"),
("TXT_KEY_UHV_IND1", "TXT_KEY_UHV_IND2", "TXT_KEY_UHV_IND3"),
("TXT_KEY_UHV_CHI1", "TXT_KEY_UHV_CHI2", "TXT_KEY_UHV_CHI3"),
("TXT_KEY_UHV_GRE1", "TXT_KEY_UHV_GRE2", "TXT_KEY_UHV_GRE3"),
("TXT_KEY_UHV_PER1", "TXT_KEY_UHV_PER2", "TXT_KEY_UHV_PER3"),
("TXT_KEY_UHV_ROM1", "TXT_KEY_UHV_ROM2", "TXT_KEY_UHV_ROM3"),
("TXT_KEY_UHV_JAP1", "TXT_KEY_UHV_JAP2", "TXT_KEY_UHV_JAP3"),
("TXT_KEY_UHV_ARA1", "TXT_KEY_UHV_ARA2", "TXT_KEY_UHV_ARA3"),
("TXT_KEY_UHV_SPA1", "TXT_KEY_UHV_SPA2", "TXT_KEY_UHV_SPA3"),
("TXT_KEY_UHV_FRA1", "TXT_KEY_UHV_FRA2", "TXT_KEY_UHV_FRA3"),
("TXT_KEY_UHV_ENG1", "TXT_KEY_UHV_ENG2", "TXT_KEY_UHV_ENG3"),
("TXT_KEY_UHV_GER1", "TXT_KEY_UHV_GER2", "TXT_KEY_UHV_GER3"),
("TXT_KEY_UHV_RUS1", "TXT_KEY_UHV_RUS2", "TXT_KEY_UHV_RUS3"),
("TXT_KEY_UHV_MAL1", "TXT_KEY_UHV_MAL2", "TXT_KEY_UHV_MAL3"),
("TXT_KEY_UHV_INC1", "TXT_KEY_UHV_INC2", "TXT_KEY_UHV_INC3"),
("TXT_KEY_UHV_MON1", "TXT_KEY_UHV_MON2", "TXT_KEY_UHV_MON3"),
("TXT_KEY_UHV_AZT1", "TXT_KEY_UHV_AZT2", "TXT_KEY_UHV_AZT3"),
("TXT_KEY_UHV_AME1", "TXT_KEY_UHV_AME2", "TXT_KEY_UHV_AME3")
)


# date waypoints

i3000BC = 0
i2250BC = 25
i2085BC = 31
i2000BC = 34
i1800BC = 42
i1600BC = 50
i1000BC = 74
i850BC = 84
i700BC = 94
i650BC = 97
i600BC = 101
i483BC = 108
i479BC = 109
i400BC = 114 #new timeline
i350BC = 117
i250BC = 124 #new timeline
i210BC = 127
i110BC = 133
i100BC = 134 #new timeline
i10BC = 140
i33AD = 143
i50AD = 144
i140AD = 150 #new timeline
i170AD = 152
i190AD = 153
i200AD = 154 #new timeline
i250AD = 157
i300AD = 161
i350AD = 164
i450AD = 171
i470AD = 172 #new timeline
i476AD = 172
i500AD = 174 #new timeline
i550AD = 177
i600AD = 181
i622AD = 183
i690AD = 190
i700AD = 191
i860AD = 207
i900AD = 211
i920AD = 213
i1000AD = 221
i1100AD = 231
i1140AD = 235
i1190AD = 240
i1200AD = 241
i1250AD = 246
i1300AD = 251
i1350AD = 256
i1400AD = 261
i1450AD = 271
i1500AD = 281
i1600AD = 301
i1607AD = 302
i1650AD = 311
i1700AD = 321
i1715AD = 326
i1730AD = 331
i1745AD = 336
i1760AD = 341
i1775AD = 346
i1800AD = 355
i1820AD = 361
i1850AD = 372
i1860AD = 377
i1870AD = 382
i1880AD = 387
i1900AD = 397
i1910AD = 402
i1918AD = 406
i1930AD = 412
i1940AD = 420
i1950AD = 430
i2000AD = 480



# starting locations coordinates
tCapitals = (
(69, 33), #tThebes
(90, 40), #tDelhi
(102, 47), #tBeijing
(67, 41), #tAthens
(82, 39), #tPersepolis
(60, 44), #tRome
(113, 45), #tKyoto
(75, 33), #tMecca
(52, 43), #tMadrid
(55, 50), #tParis
(53, 54), #tLondon
(62, 52), #tBerlin
(73, 54), #tMoskow
(53, 31), #tTimbuktu
(28, 22), #tCuzco
(99, 51), #tKarakorum
(18, 37), #tTenochtitlan
(27, 46)) #tWashington


#core areas (for RiseAndFall and Victory)

tCoreAreasTL = (
(66, 30), #Egypt
(87, 33), #India
(99, 41), #China
(65, 39), #Greece
(79, 37), #Persia
(59, 40), #Rome
(111, 41), #Japan
(73, 30), #Arabia
(49, 40), #Spain
(54, 47), #France
(50, 53), #England
(59, 48), #Germany
(67, 50), #Russia
(49, 26), #Mali
(24, 18), #Inca
(90, 48), #Mongolia
(15, 35), #Aztecs
(26, 42)) #America

tCoreAreasBR = (
(70, 36), #Egypt
(94, 40), #India
(107, 47), #China
(70, 44), #Greece
(85, 44), #Persia
(63, 47), #Rome
(116, 49), #Japan
(81, 39), #Arabia
(55, 46), #Spain
(57, 52), #France
(54, 60), #England
(66, 54), #Germany
(74, 57), #Russia
(57, 31), #Mali
(29, 24), #Inca
(105, 58), #Mongolia
(20, 41), #Aztecs
(31, 48)) #America


tExceptions = ( #for RiseAndFall
(), #Egypt
(), #India
(), #China
(), #Greece
(), #Persia
(), #Rome
(), #Japan
((82, 34), (73, 40), (74, 40), (75, 40), (76, 40), (77, 40), (71, 36), (72, 37)),  #Arabia
(), #Spain
((51, 50), (52, 49), (52, 50), (53, 47), (53, 48), (53, 49), (53, 50), (53, 51), (55, 46), (56, 46), (57, 46), (56, 45), (57, 45), (58, 48), (58, 49), (58, 50)), #France
(), #England
((62, 47), (63, 47), (64, 47), (58, 51), (58, 52), (58, 53), (57, 53), (65, 55), (66, 55), (66, 56)),  #Germany
((68, 58), (69, 58), (70, 58), (65, 55), (66, 55), (66, 56)), #Russia
(), #Mali
(), #Inca
((90, 47), (91, 47), (92, 47), (93, 47), (94, 47), (95, 47), (96, 47), (97, 47), (98, 47)), #Mongolia
(), #Aztecs
((29, 49), (30, 49), (31, 49), (31, 50), (32, 50), (24, 44), (25, 44), (24, 43), (25, 43))) #America



#normal areas (for Victory)

tNormalAreasTL = (
(65, 30), #Egypt
(86, 29), #India
(99, 39), #China
(64, 39), #Greece
(79, 37), #Persia
(57, 40), #Rome
(111, 41), #Japan
(73, 30), #Arabia
(49, 40), #Spain
(51, 46), #France
(50, 53), #England
(59, 48), #Germany
(68, 49), #Russia
(48, 26), #Mali
(24, 14), #Inca
(92, 48), #Mongolia
(15, 35), #Aztecs
(11, 43)) #America

tNormalAreasBR = (
(72, 37), #Egypt
(97, 42), #India
(108, 50), #China
(68, 44), #Greece
(86, 46), #Persia
(63, 47), #Rome
(116, 52), #Japan
(82, 38), #Arabia
(55, 46), #Spain
(58, 52), #France
(54, 60), #England
(66, 54), #Germany
(83, 62), #Russia
(60, 33), #Mali
(30, 29), #Inca
(104, 54), #Mongolia
(23, 40), #Aztecs
(31, 49)) #America


tNormalAreasSubtract = (  #for resurrection and stability
((72, 37), (70, 30), (71, 30), (72, 30)), #Egypt
((93, 42), (94, 42), (95, 42), (96, 42)), #India
((99, 49), (100, 49), (101, 49), (99, 50), (100, 50), (101, 50), (102, 50)), #China
(), #Greece
((86, 39), (86, 38), (86, 37)), #Persia
((62, 47), (63, 47), (63, 46)), #Rome
((111, 52), (112, 52), (111, 51)), #Japan
((81, 38), (82, 38), (82, 37)),  #Arabia
(), #Spain
((51, 46), (52, 46), (53, 46), (58, 47), (58, 46)), #France
(), #England
(),  #Germany
((80, 49), (68, 62), (68, 61), (68, 60), (68, 59)), #Russia
(), #Mali
(), #Inca
((92, 52), (92, 53), (92, 54), (93, 54), (94, 54), (100, 48), (101, 48), (102, 48), (103, 48), (104, 48)), #Mongolia
(), #Aztecs
()) #America



# broader areas coordinates (top left and bottom right) (for RiseAndFall)
tBroaderAreasTL = (
(60, 26), #Egypt
(85, 28), #India
(95, 38), #China
(62, 39), #Greece
(70, 37), #Persia
(49, 35), #Rome
(110, 40), #Japan
(64, 30), #Arabia
(49, 38), #Spain
(49, 44), #France
(48, 53), #England
(55, 46), #Germany
(65, 48), #Russia
(48, 21), #Mali
(24, 14), #Inca
(82, 44), #Mongolia
(14, 32), #Aztecs
(10, 42)) #America

tBroaderAreasBR = (
(74, 38), #Egypt
(99, 43), #India
(108, 50), #China
(77, 47), #Greece
(87, 49), #Persia
(73, 50), #Rome
(116, 56), #Japan
(85, 44), #Arabia
(55, 46), #Spain
(61, 52), #France
(54, 60), #England
(67, 56), #Germany
(92, 59), #Russia
(67, 32), #Mali
(30, 27), #Inca
(110, 62), #Mongolia
(24, 43), #Aztecs
(37, 56)) #America



#Mercenaries. Higher number = less likely to hire
tHire = (
10, #Egypt
30, #India
30, #China
50, #Greece
20, #Persia
30, #Rome
60, #Japan
50, #Arabia
50, #Spain
50, #France
50, #England
60, #Germany
60, #Russia
30, #Mali
30, #Inca
70, #Mongolia
30, #Aztec
50, #America
100) #Barbs



#rnf. Some civs have a double entry, for a higher chance
lEnemyCivsOnSpawn = [
[], #Egypt
[], #India
[], #China
[], #Greece
[iGreece], #Persia
[iEgypt,iGreece,iGreece], #Rome
[], #Japan
[iEgypt,iGreece,iPersia,iRome,iSpain,iFrance], #Arabia
[iArabia], #Spain
[iArabia], #France
[], #England
[iRome], #Germany
[], #Russia
[], #Mali
[], #Inca
[iIndia,iChina,iChina,iJapan,iPersia,iRussia,iRussia], #Mongolia
[], #Aztec
[] #America
]


#AIWars
tAggressionLevel = (
0, #Egypt
0, #India
1, #China
1, #Greece
2, #Persia
2, #Rome
1, #Japan
2, #Arabia
2, #Spain
1, #France
1, #England
2, #Germany
1, #Russia
0, #Mali
1, #Inca
2, #Mongolia
1, #Aztec
2, #America
0) #Barbs


#war during rise of new civs
tAIStopBirthThreshold = (
    80, #Egypt
    80, #India
    60, #China
    80, #Greece
    70, #Persia
    80, #Rome
    80, #Japan
    80, #Arabia
    60, #Spain
    60, #France
    50, #England
    70, #Germany
    50, #Russia
    70, #Mali
    70, #Inca
    70, #Mongolia
    50, #Aztec
    50, #America
    100)


#RiseAndFall
tResurrectionProb = (
80, #Egypt
100, #India
100, #China
70, #Greece
100, #Persia
65, #Rome
100, #Japan
100, #Arabia
100, #Spain
100, #France
100, #England
100, #Germany
100, #Russia
40, #Mali
80, #Inca
80, #Mongolia
80, #Aztec
100, #America
100) #Barbs 

#Congresses.
tPatienceThreshold = (
30, #Egypt
50, #India
30, #China
35, #Greece
30, #Persia
25, #Rome
25, #Japan
30, #Arabia
20, #Spain
20, #France
20, #England
20, #Germany
30, #Russia
35, #Mali
35, #Inca
20, #Mongolia
30, #Aztec
30, #America
100) #Barbs


#RnF Colonists
tMaxColonists = (
0, #Egypt
0, #India
0, #China
0, #Greece
0, #Persia
0, #Rome
0, #Japan
0, #Arabia
6, #Spain
6, #France
6, #England
1, #Germany
0, #Russia
0, #Mali
0, #Inca
0, #Mongolia
0, #Aztec
0) #America


# initialise religion variables to religion indices from XML
iJudaism = 0
iChristianity = 1
iIslam = 2
iHinduism = 3
iBuddhism = 4
iConfucianism = 5
iTaoism = 6
iNumReligions = 7


# initialise tech variables to unit indices from XML

iMysticism = 0
iMeditation = 1
iPolytheism = 2
iPriesthood = 3
iMonotheism = 4
iMonarchy = 5
iLiterature = 6
iCodeOfLaws = 7
iDrama = 8
iFeudalism = 9
iTheology = 10
iMusic = 11
iCivilService = 12
iGuilds = 13
iDivineRight = 14
iNationalism = 15
iMilitaryTradition = 16
iConstitution = 17
iLiberalism = 18
iDemocracy = 19
iCorporation = 20
iFascism = 21
iCommunism = 22
iMassMedia = 23
iEcology = 24

iFishing = 25
iTheWheel = 26
iAgriculture = 27
iPottery = 28
iSailing = 29
iWriting = 30
iMathematics = 31
iAlphabet = 32
iCalendar = 33
iCurrency = 34
iPhilosophy = 35
iPaper = 36
iBanking = 37
iEducation = 38
iPrintingPress = 39
iEconomics = 40
iAstronomy = 41
iChemistry = 42
iScientificMethod = 43
iPhysics = 44
iBiology = 45
iMedicine = 46
iElectricity = 47
iCombustion = 48
iFission = 49
iFlight = 50
iPlastics = 51
iComposites = 52
iGenetics = 53
iFiberOptics = 54
iFusion = 55

iHunting = 56
iMining = 57
iArchery = 58
iMasonry = 59
iAnimalHusbandry = 60
iBronzeWorking = 61
iHorsebackRiding = 62
iIronWorking = 63
iMetalCasting = 64
iCompass = 65
iConstruction = 66
iMachinery = 67
iEngineering = 68
iOptics = 69
iGunpowder = 70
iReplaceableParts = 71
iRifling = 72
iSteamPower = 73
iSteel = 74
iAssemblyLine = 75
iRailroad = 76
iArtillery = 77
iIndustrialism = 78
iRadio = 79
iRefrigeration = 80
iComputers = 81
iRocketry = 82
iSatellites = 83
iRobotics = 84

iNumTechs = 85
iFutureTech = 85

iNumTechsFuture = 86



# initialise unit variables to unit indices from XML

iLion = 0
iBear = 1
iPanther = 2
iWolf = 3
iSettler = 4
iWorker = 5
iFastWorker = 6
iScout = 7
iExplorer = 8
iSpy = 9
iMissionary_Jewish = 10
iMissionary_Christian = 11
iMissionary_Islamic = 12
iMissionary_Hindu = 13
iMissionary_Buddhist = 14
iMissionary_Confucian = 15
iMissionary_Taoist = 16
iWarrior = 17
iQuechua = 18
iSwordsman = 19
iJaguar = 20
iPraetorian = 21
iAxeman = 22
iMaceman = 23
iSamurai = 24
iSpearman = 25
iSpearman_Phalanx = 26
iPikeman = 27
iMusketman = 28
iMusketeer = 29
iRifleman = 30
iRedCoat = 31
iGrenadier = 32
iInfantry = 33
iSAM_Infantry = 34
iMarine = 35
iNavy_Seal = 36
iMechanizedInfantry = 37
iArcher = 38
iSkirmisher = 39
iLongbowman = 40
iCrossbowman = 41
iChoKoNu = 42
iChariot = 43
iChariot_WarChariot = 44
iImmortal = 45
iHorseArcher = 46
iKeshik = 47
iKnight = 48
iCamelArcher = 49
iConquistador = 50
iCavalry = 51
iCossack = 52
iWarElephant = 53
iTank = 54
iPanzer = 55
iModernArmor = 56
iGunship = 57
iCatapult = 58
iCannon = 59
iMachineGun = 60
iArtillery = 61
iWorkBoat = 62
iGalley = 63
iCaravel = 64
iGalleon = 65
iFrigate = 66
iIronclad = 67
iTransport = 68
iDestroyer = 69
iBattleship = 70
iSubmarine = 71
iCarrier = 72
iFighter = 73
iJetFighter = 74
iBomber = 75
iStealthBomber = 76
iICBM = 77
iGreatProphet = 78
iGreatArtist = 79
iGreatScientist = 80
iGreatTycoon = 81
iGreatEngineer = 82




# initialise bonuses variables to bonuses IDs from WBS
iAluminium = 0
iCoal = 1
iCopper = 2
iHorse = 3
iIron = 4
iMarble = 5
iOil = 6 
iStone = 7
iUranium = 8
iBanana = 9
iClam = 10
iCorn = 11
iCow = 12
iCrab = 13
iDeer = 14
iFish = 15
iPig = 16
iRice = 17
iSheep = 18
iWheat = 19
iDye = 20
iFur = 21
iGems = 22
iGold = 23
iIncense = 24
iIvory = 25
iSilk = 26
iSilver = 27
iSpices = 28
iSugar = 29
iWine = 30
iWhales = 31


#Buildings
iTemple = 36 #generic
iCathedral = 37 #generic
iShrine = 39 #generic

iPalace = 0
#iGreatPalace = 1
iSummerPalace = 1
#iVersailles = 2
iForbiddenPalace = 2
iWalls = 3
iCastle = 4
iBarracks = 5
iBunker = 6
iBombShelter = 7
iGranary = 8
iAqueduct = 9
iHospital = 10
iRecyclingCenter = 11
iLighthouse = 12
iHarbor = 13
iDrydock = 14
iAirport = 15
iForge = 16
iFactory = 17
iCoalPlant = 18
iHydroPlant = 19
iNuclearPlant = 20
iObelisk = 21
iAcademy = 22
iLibrary = 23
iUniversity = 24
iObservatory = 25
iLaboratory = 26
iTheatre = 27
iColosseum = 28
iBroadcastTower = 29
iMarket = 30
iGrocer = 31
iBank = 32
iSupermarket = 33
iCourthouse = 34
iJail = 35
iJewishTemple = 36
iJewishCathedral = 37
iJewishMonastery = 38
iJewishShrine = 39
iChristianTemple = 40
iChristianCathedral = 41
iChristianMonastery = 42
iChristianShrine = 43
iIslamicTemple = 44
iIslamicCathedral = 45
iIslamicMonastery = 46
iIslamicShrine = 47
iHinduTemple = 48
iHinduCathedral = 49
iHinduMonastery = 50
iHinduShrine = 51
iBuddhistTemple = 52
iBuddhistCathedral = 53
iBuddhistMonastery = 54
iBuddhistShrine = 55
iConfucianTemple = 56
iConfucianCathedral = 57
iConfucianMonastery = 58
iConfucianShrine = 59
iTaoistTemple = 60
iTaoistCathedral = 61
iTaoistMonastery = 62
iTaoistShrine = 63
iHeroicEpic = 64 #
iFlavianAmphitheatre = 64
iNationalEpic = 65
iTriumphalArch = 65 #
iGlobeTheatre = 66
iHermitage = 67
iNationalGallery = 67 #
iOxfordUniversity = 68
iChannelTunnel = 68 #
iWallStreet = 69
iIronWorks = 70
iWestPoint = 71
iTradingCompany = 71
iMtRushmore = 72
iRedCross = 73
iScotlandYard = 74
iInterpol = 74 #
iPyramid = 75
iStonehenge = 76
iGreatLibrary = 77
iGreatLighthouse = 78
iHangingGarden = 79
iColossus = 80
iOracle = 81
iParthenon = 82
iAngkorWat = 83
iHagiaSophia = 84
iChichenItza = 85
iTempleOfKukulkan = 85
iSistineChapel = 86
iSpiralMinaret = 87
iNotreDame = 88
iTajMahal = 89
iKremlin = 90
iEiffelTower = 91
iStatueOfLiberty = 92
iBroadway = 93
iWembley = 93
iRocknroll = 94
iHollywood = 95
iGreatDam = 96
iPentagon = 97
iUnitedNations = 98
iSpaceElevator = 99
iLeaningTower = 100
iOlympicPark = 101
iNumBuildings = 102
iPlague = 102
iNumBuildingsPlague = 103
iEgyptEmbassy = 103
iIndiaEmbassy = 104
iChinaEmbassy = 105
iGreeceEmbassy = 106
iPersiaEmbassy = 107
iRomeEmbassy = 108
iJapanEmbassy = 109
iArabiaEmbassy = 110
iSpainEmbassy = 111
iFranceEmbassy = 112
iEnglandEmbassy = 113
iGermanyEmbassy = 114
iRussiaEmbassy = 115
iMaliEmbassy = 116
iIncaEmbassy = 117
iMongoliaEmbassy = 118
iAztecsEmbassy = 119
iAmericaEmbassy = 120
iNumBuildingsEmbassy = 121

#Projects

iManhattanProject = 0
iTheInternet = 1
iSDI = 2
iApolloProgram = 3
iSSCasing = 4
iSSThrusters = 5
iSSEngine = 6
iSSDockingBay = 7
iSSCockpit = 8
iSSLifeSupport = 9
iSSStasisChamber = 10


#Eras

iAncient = 0
iClassical = 1
iMedieval = 2
iRenaissance = 3
iIndustrial = 4
iModern = 5
iFuture = 6


#Improvements

iHut = 3
iCottage = 19
iHamlet = 20
iVillage = 21
iTown = 22

#feature & terrain

iSeaIce = 0
iJungle = 1
iOasis = 2
iFloodPlains = 3
iForest = 4
iFallout = 5
iMud = 6

iGrass = 0
iPlains = 1
iDesert = 2
iTundra = 3
iSnow = 4
iCoast = 5
iOcean = 6
iTerrainPeak = 7
iTerrainHills = 8
iMarsh = 9

iSwamp = 36 #bonus


#Stability Parameters

iParCities3 = 0
iParCitiesE = 1
iParCivics3 = 2
iParCivics1 = 3
iParCivicsE = 4
iParDiplomacy3 = 5
iParDiplomacyE = 6
iParEconomy3 = 7
iParEconomy1 = 8
iParEconomyE = 9
iParExpansion3 = 10
iParExpansion1 = 11
iParExpansionE = 12
iNumStabilityParameters = 13

#Plague
iImmunity = 20


#leaders

iLeaderBarbarian = 0
iAlexander = 1
iAsoka = 2
iBismarck = 3
iCatherine = 4
iCyrus = 5
iElizabeth = 6
iFrederick = 7
iGandhi = 8
iGenghis_khan = 9
iHatshepsut = 10
iHuayna_capac = 11
iIsabella = 12
iJulius_caesar = 13
iKublai_khan = 14
iLouisxiv = 15
iMansa_musa = 16
iMao = 17
iMontezuma = 18
iNapoleon = 19
iPeter = 20
iQin_shi_huang = 21
iRoosevelt = 22
iSaladin = 23
iTokugawa = 24
iVictoria = 25
iWashington = 26

tLeaders = (
(iHatshepsut,),
(iAsoka, iGandhi),
(iQin_shi_huang, iMao),
(iAlexander,),
(iCyrus,),
(iJulius_caesar,),
(iTokugawa,),
(iSaladin,),
(iIsabella,),
(iLouisxiv, iNapoleon),
(iVictoria, iElizabeth),
(iBismarck, iFrederick),
(iPeter, iCatherine),
(iMansa_musa,),
(iHuayna_capac,),
(iGenghis_khan, iKublai_khan),
(iMontezuma,),
(iRoosevelt, iWashington))

tEarlyLeaders = (
(iHatshepsut), 
(iAsoka),
(iQin_shi_huang),
(iAlexander),
(iCyrus),
(iJulius_caesar),
(iTokugawa),
(iSaladin),
(iIsabella),
(iLouisxiv),
(iElizabeth),
(iFrederick),
(iPeter),
(iMansa_musa),
(iHuayna_capac),
(iGenghis_khan),
(iMontezuma),
(iWashington))


tLateLeaders = ( #all up to 300 turns earlier because the switch is triggered after a few years
(iHatshepsut,), 
(iGandhi, i1700AD, 5, 4),
(iMao, i1800AD, 10, 4),
(iAlexander,),
(iCyrus,),
(iJulius_caesar,),
(iTokugawa,),
(iSaladin,),
(iIsabella,),
(iNapoleon, i1700AD, 10, 4),
(iVictoria, i1600AD, 15, 3),
(iBismarck, i1700AD, 10, 4),
(iCatherine, i1700AD, 10, 4),
(iMansa_musa,),
(iHuayna_capac,),
(iKublai_khan, i1500AD, 10, 3),
(iMontezuma,),
(iRoosevelt, i1850AD, 15, 5))
